Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Finish.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Finish.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Finish.nsh	(revision 2956)
@@ -50,8 +50,8 @@
   !endif
   
   !ifdef MUI_FINISHPAGE_SHOWREADME
-    !ifndef MUI_FINISHPAGE_SHOREADME_VARAIBLES
-      !define MUI_FINISHPAGE_SHOREADME_VARAIBLES
+    !ifndef MUI_FINISHPAGE_SHOWREADME_VARIABLES
+      !define MUI_FINISHPAGE_SHOWREADME_VARIABLES
       Var mui.FinishPage.ShowReadme
     !endif
   !endif
@@ -71,7 +71,10 @@
     !endif
   !endif
 
-  !insertmacro MUI_DEFAULT MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"  
+  !insertmacro MUI_DEFAULT MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"
+  !if "${MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP}" == ""
+    !error "Invalid MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP"
+  !endif
 
 !macroend
 
@@ -264,11 +267,7 @@
     ;Image control
     ${NSD_CreateBitmap} 0u 0u 109u 193u ""
     Pop $mui.FinishPage.Image
-    !ifndef MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
-      ${NSD_SetStretchedImage} $mui.FinishPage.Image $PLUGINSDIR\modern-wizard.bmp $mui.FinishPage.Image.Bitmap
-    !else
-      ${NSD_SetImage} $mui.FinishPage.Image $PLUGINSDIR\modern-wizard.bmp $mui.FinishPage.Image.Bitmap
-    !endif
+    !insertmacro MUI_INTERNAL_FULLWINDOW_LOADWIZARDIMAGE "${MUI_PAGE_UNINSTALLER_PREFIX}" $mui.FinishPage.Image $PLUGINSDIR\modern-wizard.bmp $mui.FinishPage.Image.Bitmap
     
     ;Positiong of controls
 
@@ -328,22 +327,22 @@
         ;Title text
         ${NSD_CreateLabel} 120u 10u 195u ${MUI_FINISHPAGE_TITLE_HEIGHT}u "${MUI_FINISHPAGE_TITLE}"
         Pop $mui.FinishPage.Title
-        SetCtlColors $mui.FinishPage.Title "" "${MUI_BGCOLOR}"
+        SetCtlColors $mui.FinishPage.Title "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
         CreateFont $mui.FinishPage.Title.Font "$(^Font)" "12" "700"
         SendMessage $mui.FinishPage.Title ${WM_SETFONT} $mui.FinishPage.Title.Font 0
 
         ;Finish text
-        ${NSD_CreateLabel} 120u 45u 195u ${MUI_FINISHPAGE_TEXT_HEIGHT_BUTTONS}u "${MUI_FINISHPAGE_TEXT_REBOOT}"
+        ${NSD_CreateLabel} 120u ${MUI_FINISHPAGE_TEXT_TOP}u 195u ${MUI_FINISHPAGE_TEXT_HEIGHT_BUTTONS}u "${MUI_FINISHPAGE_TEXT_REBOOT}"
         Pop $mui.FinishPage.Text
-        SetCtlColors $mui.FinishPage.Text "" "${MUI_BGCOLOR}"
+        SetCtlColors $mui.FinishPage.Text "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
       
         ;Radio buttons for reboot page
         ${NSD_CreateRadioButton} 120u ${MUI_FINISHPAGE_REBOOTNOW_TOP}u 195u 10u "${MUI_FINISHPAGE_TEXT_REBOOTNOW}"
         Pop $mui.FinishPage.RebootNow
-        SetCtlColors $mui.FinishPage.RebootNow "" "${MUI_BGCOLOR}"        
+        SetCtlColors $mui.FinishPage.RebootNow "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"        
         ${NSD_CreateRadioButton} 120u ${MUI_FINISHPAGE_REBOOTLATER_TOP}u 195u 10u "${MUI_FINISHPAGE_TEXT_REBOOTLATER}"
         Pop $mui.FinishPage.RebootLater
-        SetCtlColors $mui.FinishPage.RebootLater "" "${MUI_BGCOLOR}"
+        SetCtlColors $mui.FinishPage.RebootLater "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
         !ifndef MUI_FINISHPAGE_REBOOTLATER_DEFAULT
           SendMessage $mui.FinishPage.RebootNow ${BM_SETCHECK} ${BST_CHECKED} 0
         !else
@@ -358,7 +357,7 @@
         ;Title text
         ${NSD_CreateLabel} 120u 10u 195u ${MUI_FINISHPAGE_TITLE_HEIGHT}u "${MUI_FINISHPAGE_TITLE}"
         Pop $mui.FinishPage.Title
-        SetCtlColors $mui.FinishPage.Title "" "${MUI_BGCOLOR}"
+        SetCtlColors $mui.FinishPage.Title "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
         CreateFont $mui.FinishPage.Title.Font "$(^Font)" "12" "700"
         SendMessage $mui.FinishPage.Title ${WM_SETFONT} $mui.FinishPage.Title.Font 0
 
@@ -369,13 +368,13 @@
           ${NSD_CreateLabel} 120u ${MUI_FINISHPAGE_TEXT_TOP}u 195u ${MUI_FINISHPAGE_TEXT_HEIGHT_BUTTONS}u "${MUI_FINISHPAGE_TEXT}"
         !endif
         Pop $mui.FinishPage.Text
-        SetCtlColors $mui.FinishPage.Text "" "${MUI_BGCOLOR}"
+        SetCtlColors $mui.FinishPage.Text "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
     
         ;Checkboxes
         !ifdef MUI_FINISHPAGE_RUN
           ${NSD_CreateCheckbox} 120u ${MUI_FINISHPAGE_RUN_TOP}u 195u 10u "${MUI_FINISHPAGE_RUN_TEXT}"
           Pop $mui.FinishPage.Run
-          SetCtlColors $mui.FinishPage.Run "" "${MUI_BGCOLOR}"
+          SetCtlColors $mui.FinishPage.Run "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
           !ifndef MUI_FINISHPAGE_RUN_NOTCHECKED
             SendMessage $mui.FinishPage.Run ${BM_SETCHECK} ${BST_CHECKED} 0
           !endif
@@ -384,7 +383,7 @@
         !ifdef MUI_FINISHPAGE_SHOWREADME
           ${NSD_CreateCheckbox} 120u ${MUI_FINISHPAGE_SHOWREADME_TOP}u 195u 10u "${MUI_FINISHPAGE_SHOWREADME_TEXT}"
           Pop $mui.FinishPage.ShowReadme
-          SetCtlColors $mui.FinishPage.ShowReadme "" "${MUI_BGCOLOR}"
+          SetCtlColors $mui.FinishPage.ShowReadme "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
           !ifndef MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
             SendMessage $mui.FinishPage.ShowReadme ${BM_SETCHECK} ${BST_CHECKED} 0
           !endif
@@ -409,10 +408,29 @@
       StrCpy $mui.FinishPage.DisableAbortWarning "1"
     !endif
 
+    !ifndef MUI_FORCECLASSICCONTROLS
+    ${If} ${IsHighContrastModeActive}
+    !endif
+      ; SetCtlColors does not change the check/radio text color (bug #443)
+      !ifndef MUI_FINISHPAGE_NOREBOOTSUPPORT
+        System::Call 'UXTHEME::SetWindowTheme(p$mui.FinishPage.RebootNow,w" ",w" ")'
+        System::Call 'UXTHEME::SetWindowTheme(p$mui.FinishPage.RebootLater,w" ",w" ")'
+      !endif
+      !ifdef MUI_FINISHPAGE_RUN
+        System::Call 'UXTHEME::SetWindowTheme(p$mui.FinishPage.Run,w" ",w" ")'
+      !endif
+      !ifdef MUI_FINISHPAGE_SHOWREADME
+        System::Call 'UXTHEME::SetWindowTheme(p$mui.FinishPage.ShowReadme,w" ",w" ")'
+      !endif
+    !ifndef MUI_FORCECLASSICCONTROLS
+    ${EndIf}
+    !endif
+
     ;Show page
     Call ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}muiPageLoadFullWindow
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
     nsDialogs::Show
+    !insertmacro MUI_PAGE_FUNCTION_CUSTOM DESTROYED
     Call ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}muiPageUnloadFullWindow 
     
     !ifdef MUI_FINISHPAGE_CANCEL_ENABLED
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/License.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/License.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/License.nsh	(revision 2956)
@@ -80,8 +80,6 @@
     !insertmacro MUI_UNSET MUI_LICENSEPAGE_CHECKBOX_TEXT_ACCEPT
     !insertmacro MUI_UNSET MUI_LICENSEPAGE_CHECKBOX_TEXT_DECLINE
 
-  !verbose pop
-
 !macroend
 
 !macro MUI_PAGE_LICENSE LICENSEDATA
@@ -123,7 +121,7 @@
 
   Function "${SHOW}"
 
-    ;Get conrol handles
+    ;Get control handles
     FindWindow $mui.LicensePage "#32770" "" $HWNDPARENT
     GetDlgItem $mui.LicensePage.TopText $mui.LicensePage 1040
     GetDlgItem $mui.LicensePage.Text $mui.LicensePage 1006
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/StartMenu.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/StartMenu.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/StartMenu.nsh	(revision 2956)
@@ -136,13 +136,14 @@
     GetDlgItem $mui.StartMenuPage.FolderList $mui.StartMenuPage 1004
 
     !ifdef MUI_STARTMENUPAGE_BGCOLOR
-      SetCtlColors $mui.StartMenuPage.Location "" "${MUI_STARTMENUPAGE_BGCOLOR}"
-      SetCtlColors $mui.StartMenuMenu.FolderList "" "${MUI_STARTMENUPAGE_BGCOLOR}"
+      !insertmacro MUI_DEFAULT MUI_STARTMENUPAGE_TEXTCOLOR ""
+      SetCtlColors $mui.StartMenuPage.Location "${MUI_STARTMENUPAGE_TEXTCOLOR}" "${MUI_STARTMENUPAGE_BGCOLOR}"
+      SetCtlColors $mui.StartMenuMenu.FolderList "${MUI_STARTMENUPAGE_TEXTCOLOR}" "${MUI_STARTMENUPAGE_BGCOLOR}"
     !endif
 
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
-
     StartMenu::Show
+    !insertmacro MUI_PAGE_FUNCTION_CUSTOM DESTROYED
 
     Pop $mui.StartMenuPage.Temp
     ${if} $mui.StartMenuPage.Temp ==  "success"
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Directory.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Directory.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Directory.nsh	(revision 2956)
@@ -16,12 +16,12 @@
     
     Var mui.DirectoryPage.Text
     
-    Var mui.DirectoryPage.DirectoryBox        
+    Var mui.DirectoryPage.DirectoryBox
     Var mui.DirectoryPage.Directory
     Var mui.DirectoryPage.BrowseButton
     
     Var mui.DirectoryPage.SpaceRequired
-    Var mui.DirectoryPage.SpaceAvailable    
+    Var mui.DirectoryPage.SpaceAvailable
   !endif
 
 !macroend
@@ -106,13 +106,14 @@
     FindWindow $mui.DirectoryPage "#32770" "" $HWNDPARENT
     GetDlgItem $mui.DirectoryPage.Text $mui.DirectoryPage 1006
     GetDlgItem $mui.DirectoryPage.DirectoryBox $mui.DirectoryPage 1020
-    GetDlgItem $mui.DirectoryPage.Directory $mui.DirectoryPage 1019 
+    GetDlgItem $mui.DirectoryPage.Directory $mui.DirectoryPage 1019
     GetDlgItem $mui.DirectoryPage.BrowseButton $mui.DirectoryPage 1001
-    GetDlgItem $mui.DirectoryPage.SpaceRequired $mui.DirectoryPage 1023    
+    GetDlgItem $mui.DirectoryPage.SpaceRequired $mui.DirectoryPage 1023
     GetDlgItem $mui.DirectoryPage.SpaceAvailable $mui.DirectoryPage 1024
   
     !ifdef MUI_DIRECTORYPAGE_BGCOLOR
-      SetCtlColors $mui.DirectoryPage.Directory "" "${MUI_DIRECTORYPAGE_BGCOLOR}"
+      !insertmacro MUI_DEFAULT MUI_DIRECTORYPAGE_TEXTCOLOR ""
+      SetCtlColors $mui.DirectoryPage.Directory "${MUI_DIRECTORYPAGE_TEXTCOLOR}" "${MUI_DIRECTORYPAGE_BGCOLOR}"
     !endif
     
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/UninstallConfirm.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/UninstallConfirm.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/UninstallConfirm.nsh	(revision 2956)
@@ -41,6 +41,10 @@
 
     UninstallText "${MUI_UNCONFIRMPAGE_TEXT_TOP}" "${MUI_UNCONFIRMPAGE_TEXT_LOCATION}"
 
+    !ifdef MUI_UNCONFIRMPAGE_VARIABLE
+      DirVar "${MUI_UNCONFIRMPAGE_VARIABLE}"
+    !endif
+
   PageExEnd
 
   !insertmacro MUI_UNFUNCTION_CONFIRMPAGE un.mui.ConfirmPre_${MUI_UNIQUEID} un.mui.ConfirmShow_${MUI_UNIQUEID} un.mui.ConfirmLeave_${MUI_UNIQUEID}
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Welcome.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Welcome.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages/Welcome.nsh	(revision 2956)
@@ -20,10 +20,13 @@
     Var mui.WelcomePage.Title
     Var mui.WelcomePage.Title.Font
     
-    Var mui.WelcomePage.Text    
+    Var mui.WelcomePage.Text
   !endif
   
-  !insertmacro MUI_DEFAULT MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"  
+  !insertmacro MUI_DEFAULT MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\win.bmp"
+  !if "${MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP}" == ""
+    !error "Invalid MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP"
+  !endif
 
 !macroend
 
@@ -126,11 +129,7 @@
     ;Image control
     ${NSD_CreateBitmap} 0u 0u 109u 193u ""
     Pop $mui.WelcomePage.Image
-    !ifndef MUI_${MUI_PAGE_UNINSTALLER_PREFIX}WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
-      ${NSD_SetStretchedImage} $mui.WelcomePage.Image $PLUGINSDIR\modern-wizard.bmp $mui.WelcomePage.Image.Bitmap
-    !else
-      ${NSD_SetImage} $mui.WelcomePage.Image $PLUGINSDIR\modern-wizard.bmp $mui.WelcomePage.Image.Bitmap
-    !endif
+    !insertmacro MUI_INTERNAL_FULLWINDOW_LOADWIZARDIMAGE "${MUI_PAGE_UNINSTALLER_PREFIX}" $mui.WelcomePage.Image $PLUGINSDIR\modern-wizard.bmp $mui.WelcomePage.Image.Bitmap
 
     ;Positiong of controls
 
@@ -148,19 +147,20 @@
     ;Title
     ${NSD_CreateLabel} 120u 10u 195u ${MUI_WELCOMEPAGE_TITLE_HEIGHT}u "${MUI_WELCOMEPAGE_TITLE}"
     Pop $mui.WelcomePage.Title
-    SetCtlColors $mui.WelcomePage.Title "" "${MUI_BGCOLOR}"    
+    SetCtlColors $mui.WelcomePage.Title "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"    
     CreateFont $mui.WelcomePage.Title.Font "$(^Font)" "12" "700"
     SendMessage $mui.WelcomePage.Title ${WM_SETFONT} $mui.WelcomePage.Title.Font 0
 
     ;Welcome text
     ${NSD_CreateLabel} 120u ${MUI_WELCOMEPAGE_TEXT_TOP}u 195u 130u "${MUI_WELCOMEPAGE_TEXT}"
     Pop $mui.WelcomePage.Text
-    SetCtlColors $mui.WelcomePage.Text "" "${MUI_BGCOLOR}"
+    SetCtlColors $mui.WelcomePage.Text "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
 
     ;Show page
     Call ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}muiPageLoadFullWindow
     !insertmacro MUI_PAGE_FUNCTION_CUSTOM SHOW
     nsDialogs::Show
+    !insertmacro MUI_PAGE_FUNCTION_CUSTOM DESTROYED
     Call ${MUI_PAGE_UNINSTALLER_FUNCPREFIX}muiPageUnloadFullWindow    
 
     ;Delete image from memory
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/MUI2.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/MUI2.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/MUI2.nsh	(revision 2956)
@@ -1,25 +1,21 @@
 /*
 
-NSIS Modern User Interface - Version 2.0
-Copyright 2002-2015 Joost Verburg
+NSIS Modern User Interface - Version 2.1
+Copyright 2002-2020 Joost Verburg
+Contributors: Amir Szekely, Anders Kjersem
 
 */
 
-!echo "NSIS Modern User Interface version 2.0 - Copyright 2002-2015 Joost Verburg"
-
-;--------------------------------
-
 !ifndef MUI_INCLUDED
+!verbose push 3
 !define MUI_INCLUDED
+!define MUI_SYSVERSION "2.1"
+!verbose pop
+!echo "NSIS Modern User Interface version ${MUI_SYSVERSION} - Copyright 2002-2020 Joost Verburg"
 
-!define MUI_SYSVERSION "2.0"
-
-!verbose push
-
-!ifndef MUI_VERBOSE
-  !define MUI_VERBOSE 3
-!endif
-
+;--------------------------------
+!verbose push 3
+!define /IfNDef MUI_VERBOSE 3
 !verbose ${MUI_VERBOSE}
 
 !addincludedir "${NSISDIR}\Contrib\Modern UI 2"
@@ -117,6 +113,5 @@
 
 !macroend
 
-!endif
-
 !verbose pop
+!endif ;~ MUI_INCLUDED
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Pages.nsh	(revision 2956)
@@ -10,6 +10,10 @@
 
 !macro MUI_PAGE_INIT
 
+  !ifdef MUI_INSERT
+    !warning "MUI_PAGE_* inserted after MUI_LANGUAGE"
+  !endif
+
   ;Include interface settings in neccesary
   !insertmacro MUI_INTERFACE
 
@@ -29,6 +33,10 @@
 
 !macro MUI_UNPAGE_INIT
 
+  !ifdef MUI_INSERT
+    !warning "MUI_UNPAGE_* inserted after MUI_LANGUAGE"
+  !endif
+
   ;Include interface settings
   !insertmacro MUI_INTERFACE
 
@@ -41,7 +49,7 @@
   
   ;Generate unique ID
   !insertmacro MUI_UNSET MUI_UNIQUEID
-  !define MUI_UNIQUEID ${__LINE__}  
+  !define MUI_UNIQUEID ${__LINE__}
 
 !macroend
 
@@ -158,3 +166,159 @@
   !endif
 
 !macroend
+
+!macro MUI_INTERNAL_FULLWINDOW_LOADWIZARDIMAGE _un _hwndImg _ImgPath _RetImgHandle
+
+  !ifdef MUI_${_un}WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
+    !insertmacro MUI_DEFAULT MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH NoStretchNoCropNoAlign ; Legacy compatibility
+  !endif
+  !insertmacro MUI_DEFAULT MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH FitControl
+
+  !if "${MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH}" == "NoStretchNoCropNoAlign"
+
+    ${NSD_SetImage} ${_hwndImg} "${_ImgPath}" "${_RetImgHandle}"
+
+  !else if "${MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH}" == "NoStretchNoCrop"
+
+    !insertmacro MUI_LOADANDXALIGNIMAGE ${_hwndImg} "${_ImgPath}" Auto "${_RetImgHandle}"
+
+  !else if "${MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH}" == "AspectFitHeight"
+
+    !insertmacro MUI_LOADANDASPECTSTRETCHIMAGETOCONTROLHEIGHT ${_hwndImg} "${_ImgPath}" Auto "${_RetImgHandle}"
+
+  !else
+
+    !if "${MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH}" != "FitControl"
+      !warning 'MUI_${_un}WELCOMEFINISHPAGE_BITMAP_STRETCH set to unknown value, defaulting to FitControl'
+    !endif
+    ${NSD_SetStretchedImage} ${_hwndImg} "${_ImgPath}" "${_RetImgHandle}"
+
+  !endif
+
+!macroend
+
+
+;--------------------------------
+;Helper macros
+
+!include Util.nsh
+
+!macro MUI_INTERNAL_LOADANDSIZEIMAGE _macro _hwndImg _ImgPath _XAlign _RetImgHandle
+  !if "${_XAlign}" == "Auto"
+    ${if} $(^RTL) == 1
+      Push "*${_ImgPath}"
+    ${Else}
+      Push "${_ImgPath}"
+    ${EndIf}
+  !else if "${_XAlign}" == "Right"
+    Push "*${_ImgPath}"
+  !else
+    Push "${_ImgPath}"
+  !endif
+  Push "${_hwndImg}"
+  ${CallArtificialFunction} ${_macro}
+  !if "${_RetImgHandle}" == "Leak"
+    !insertmacro _LOGICLIB_TEMP
+    Pop $_LOGICLIB_TEMP
+  !else if "${_RetImgHandle}" != "Stack"
+    Pop ${_RetImgHandle}
+  !endif
+!macroend
+
+!macro MUI_LOADANDXALIGNIMAGE _hwndImg _ImgPath _XAlign _RetImgHandle
+!insertmacro MUI_INTERNAL_LOADANDSIZEIMAGE \
+  MUI_INTERNAL_LOADANDXALIGNIMAGE "${_hwndImg}" "${_ImgPath}" "${_XAlign}" "${_RetImgHandle}"
+!macroend
+!macro MUI_INTERNAL_LOADANDXALIGNIMAGE
+  System::Store "S"
+  System::Call 'USER32::GetWindowRect(psr0,@r1)'
+  System::Call 'USER32::MapWindowPoints(p0,p$hwndparent,pr1,i2)' ; Note: Assuming control is not in inner dialog
+  System::Call '*$1(i.r5,i.r6,i.r7,i.r8)'
+  IntOp $7 $7 - $5
+  IntOp $8 $8 - $6
+
+  Pop $1
+  StrCpy $3 $1 1
+  ${If} $3 == "*" ; Move control to the right?
+    StrCpy $1 $1 "" 1
+  ${Endif}
+  System::Call 'USER32::LoadImage(p0,tr1,i${IMAGE_BITMAP},i0,i0,i${LR_LOADFROMFILE})p.r2'
+  SendMessage $0 ${STM_SETIMAGE} ${IMAGE_BITMAP} $2 $1
+  Push $2 ; Return value
+  System::Call 'GDI32::DeleteObject(pr1)' ; Note: Assuming the previous image (if any) was a bitmap
+  System::Call 'USER32::GetClientRect(pr0,@r1)'
+  System::Call '*$1(i,i,i.r1,i.r2)'
+
+  ${If} $3 == "*"
+  ${AndIf} $1 < $7 ; ImgW < CtlW
+    IntOp $3 $7 - $1
+    IntOp $5 $5 + $3
+    System::Call 'USER32::SetWindowPos(pr0,p0,ir5,ir6,i,i,i0x15)'
+  ${EndIf}
+
+  System::Store "L"
+!macroend
+
+!macro MUI_LOADANDASPECTSTRETCHIMAGETOCONTROLHEIGHT _hwndImg _ImgPath _XAlign _RetImgHandle
+!insertmacro MUI_INTERNAL_LOADANDSIZEIMAGE \
+  MUI_INTERNAL_LOADANDASPECTSTRETCHIMAGETOCONTROLHEIGHT "${_hwndImg}" "${_ImgPath}" "${_XAlign}" "${_RetImgHandle}"
+!macroend
+!macro MUI_INTERNAL_LOADANDASPECTSTRETCHIMAGETOCONTROLHEIGHT
+  System::Store "S"
+  System::Call 'USER32::GetWindowRect(psr0,@r1)'
+  System::Call 'USER32::MapWindowPoints(p0,p$hwndparent,pr1,i2)' ; Note: Assuming control is not in inner dialog
+  System::Call '*$1(i.r5,i.r6,i.r7,i.r8)'
+  IntOp $7 $7 - $5
+  IntOp $8 $8 - $6
+
+  Pop $1
+  StrCpy $3 $1 1
+  ${If} $3 == "*" ; Move control to the right?
+    StrCpy $1 $1 "" 1
+  ${Endif}
+  System::Call 'USER32::LoadImage(p0,tr1,i${IMAGE_BITMAP},i0,i0,i${LR_LOADFROMFILE})p.r2'
+  SendMessage $0 ${STM_SETIMAGE} ${IMAGE_BITMAP} $2 $1
+  Push $2 ; Return value
+  System::Call 'GDI32::DeleteObject(pr1)' ; Note: Assuming the previous image (if any) was a bitmap
+  System::Call 'USER32::GetClientRect(pr0,@r1)'
+  System::Call '*$1(i,i,i.r1,i.r2)'
+
+  IntOp $R7 $7 * 10000
+  IntOp $R8 $8 * 10000
+  IntOp $R1 $1 * 10000
+  IntOp $R2 $2 * 10000
+  IntOp $R3 $R1 / $2
+  StrCpy $R4 10000
+  ${If} $R1 > $R2
+    StrCpy $R3 10000
+    IntOp $R4 $R2 / $1
+  ${EndIf}
+
+  ${DoWhile} $R2 > $R8 ; ImgH > CtlH
+    IntOp $R1 $R1 - $R3
+    IntOp $R2 $R2 - $R4
+  ${Loop}
+  ${DoWhile} $R2 < $R8 ; ImgH < CtlH
+    IntOp $R1 $R1 + $R3
+    IntOp $R2 $R2 + $R4
+  ${Loop}
+  IntOp $1 $R1 / 10000
+  IntOp $2 $R2 / 10000
+
+  ${If} $1 < $7
+  ${AndIf} $3 == "*"
+    IntOp $R3 $7 - $1
+    IntOp $5 $5 + $R3
+  ${EndIf}
+
+  ${DoWhile} $2 > $8 ; Non-aspect-maintained stretch to make it a pixel perfect match
+    IntOp $2 $2 - 1
+    IntOp $1 $1 - 1
+    ${IfThen} $3 == "*" ${|} IntOp $5 $5 + 1 ${|}
+  ${Loop}
+
+  System::Call 'USER32::SetWindowPos(pr0,p0,ir5,ir6,ir1,ir2,i0x14)'
+  System::Store "L"
+!macroend
+
+
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Deprecated.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Deprecated.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Deprecated.nsh	(revision 2956)
@@ -5,6 +5,21 @@
 
 */
 
+
+!macro MUI_LEGACY_MAP_NOSTRETCH NAME R
+  !if "${R}" != ""
+    !ifdef ${NAME}NOSTRETCH
+        !define /IfNDef ${NAME}STRETCH NoStretchNoCropNoAlign
+    !endif
+  !else
+    !insertmacro ${__MACRO__} ${NAME}BITMAP_ 1
+    !insertmacro ${__MACRO__} ${NAME}BITMAP_RTL_ 1
+    !insertmacro ${__MACRO__} ${NAME}UNBITMAP_ 1
+    !insertmacro ${__MACRO__} ${NAME}UNBITMAP_RTL_ 1
+  !endif
+!macroend
+
+
 ;--------------------------------
 ;InstallOptions
 
@@ -66,7 +81,6 @@
 
 !macro MUI_RESERVEFILE_INSTALLOPTIONS
 
-  !define MUI_DOLLAR "$"
-  !error "MUI_RESERVEFILE_INSTALLOPTIONS is no longer supported as InstallOptions is no longer used by MUI2. Instead, use ReserveFile '${MUI_DOLLAR}{NSISDIR}\Plugins\InstallOptions.dll'. It is also recommended to upgrade to nsDialogs."
+  !error `MUI_RESERVEFILE_INSTALLOPTIONS is no longer supported as InstallOptions is no longer used by MUI2. Instead, use "ReserveFile /plugin InstallOptions.dll". It is also recommended to upgrade to nsDialogs.`
 
 !macroend
Index: tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Interface.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Interface.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Contrib/Modern UI 2/Interface.nsh	(revision 2956)
@@ -49,28 +49,51 @@
     !insertmacro MUI_DEFAULT MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
     !insertmacro MUI_DEFAULT MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"
     !insertmacro MUI_DEFAULT MUI_BGCOLOR "FFFFFF"
+    !insertmacro MUI_DEFAULT MUI_TEXTCOLOR "000000"
 
+    ;Map *_NOSTRETCH legacy define to the correct *_STRETCH value
+    !verbose push 2
+    !insertmacro MUI_LEGACY_MAP_NOSTRETCH MUI_HEADERIMAGE_ ""
+    !insertmacro MUI_LEGACY_MAP_NOSTRETCH MUI_WELCOMEFINISHPAGE_ ""
+    !insertmacro MUI_LEGACY_MAP_NOSTRETCH MUI_UNWELCOMEFINISHPAGE_ ""
+    !verbose pop
+
     ;Default header images
     !ifdef MUI_HEADERIMAGE
 
       !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\nsis.bmp"
+      !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_BITMAP_STRETCH "FitControl"
+      !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_BITMAP_RTL_STRETCH ${MUI_HEADERIMAGE_BITMAP_STRETCH}
 
       !ifndef MUI_HEADERIMAGE_UNBITMAP
         !define MUI_HEADERIMAGE_UNBITMAP "${MUI_HEADERIMAGE_BITMAP}"
-        !ifdef MUI_HEADERIMAGE_BITMAP_NOSTRETCH
-          !insertmacro MUI_SET MUI_HEADERIMAGE_UNBITMAP_NOSTRETCH ""
-        !endif
+        !insertmacro MUI_SET MUI_HEADERIMAGE_UNBITMAP_STRETCH ${MUI_HEADERIMAGE_BITMAP_STRETCH}
       !endif
 
+      !if "${MUI_HEADERIMAGE_BITMAP}" == ""
+        !error "Invalid MUI_HEADERIMAGE_BITMAP"
+      !endif
+      !if "${MUI_HEADERIMAGE_UNBITMAP}" == ""
+        !error "Invalid MUI_HEADERIMAGE_UNBITMAP"
+      !endif
+
       !ifdef MUI_HEADERIMAGE_BITMAP_RTL
         !ifndef MUI_HEADERIMAGE_UNBITMAP_RTL
           !define MUI_HEADERIMAGE_UNBITMAP_RTL "${MUI_HEADERIMAGE_BITMAP_RTL}"
-          !ifdef MUI_HEADERIMAGE_BITMAP_RTL_NOSTRETCH
-            !insertmacro MUI_SET MUI_HEADERIMAGE_UNBITMAP_RTL_NOSTRETCH ""
-          !endif
+          !insertmacro MUI_SET MUI_HEADERIMAGE_UNBITMAP_RTL_STRETCH ${MUI_HEADERIMAGE_BITMAP_RTL_STRETCH}
         !endif
+
+        !if "${MUI_HEADERIMAGE_BITMAP_RTL}" == ""
+          !error "Invalid MUI_HEADERIMAGE_BITMAP_RTL"
+        !endif
+        !if "${MUI_HEADERIMAGE_UNBITMAP_RTL}" == ""
+          !error "Invalid MUI_HEADERIMAGE_UNBITMAP_RTL"
+        !endif
       !endif
 
+      !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_UNBITMAP_STRETCH ${MUI_HEADERIMAGE_BITMAP_STRETCH}
+      !insertmacro MUI_DEFAULT MUI_HEADERIMAGE_UNBITMAP_RTL_STRETCH ${MUI_HEADERIMAGE_BITMAP_RTL_STRETCH}
+
     !endif
 
     ;Default texts
@@ -133,44 +156,76 @@
 ;--------------------------------
 ;Initialization of GUI
 
-!macro MUI_HEADERIMAGE_INIT UNINSTALLER
+!macro MUI_HEADERIMAGE_INITHELPER_LOADIMAGEWITHMACRO MACRO
 
-  ;Load and display header image
+  !ifdef MUI_HEADERIMAGE_RIGHT
+    !ifndef MUI_OPTIMIZE_ALWAYSLTR ; Undocumented
+      ${if} $(^RTL) == 1
+        !insertmacro ${MACRO} $mui.Header.Image "${PATH}" Left Leak
+      ${Else}
+        !insertmacro ${MACRO} $mui.Header.Image "${PATH}" Right Leak
+      ${EndIf}
+    !else
+      !insertmacro ${MACRO} $mui.Header.Image "${PATH}" Right Leak
+    !endif
+  !else
+    !insertmacro ${MACRO} $mui.Header.Image "${PATH}" Auto Leak
+  !endif
 
-  !ifdef MUI_HEADERIMAGE
+!macroend
+!macro MUI_HEADERIMAGE_INITHELPER_LOADIMAGE UN RTL IMGRESID PATH
 
-    InitPluginsDir
+  GetDlgItem $mui.Header.Image $HWNDPARENT ${IMGRESID} ; This variable is not used by every mode but we have to reference it to avoid a compiler warning.
 
-    !ifdef MUI_HEADERIMAGE_${UNINSTALLER}BITMAP_RTL
+  !if "${MUI_HEADERIMAGE_${UN}BITMAP${RTL}_STRETCH}" == "NoStretchNoCropNoAlign"
 
-      ${if} $(^RTL) == 1
+    SetBrandingImage /IMGID=${IMGRESID} "${PATH}"
 
-        File "/oname=$PLUGINSDIR\modern-header.bmp" "${MUI_HEADERIMAGE_${UNINSTALLER}BITMAP_RTL}"
+  !else if "${MUI_HEADERIMAGE_${UN}BITMAP${RTL}_STRETCH}" == "NoStretchNoCrop"
 
-        !ifndef MUI_HEADERIMAGE_${UNINSTALLER}BITMAP_RTL_NOSTRETCH
-          SetBrandingImage /IMGID=1046 /RESIZETOFIT "$PLUGINSDIR\modern-header.bmp"
-        !else
-          SetBrandingImage /IMGID=1046 "$PLUGINSDIR\modern-header.bmp"
-        !endif
+    !insertmacro MUI_HEADERIMAGE_INITHELPER_LOADIMAGEWITHMACRO \
+      MUI_LOADANDXALIGNIMAGE
 
-      ${else}
+  !else if "${MUI_HEADERIMAGE_${UN}BITMAP${RTL}_STRETCH}" == "AspectFitHeight"
 
+    !insertmacro MUI_HEADERIMAGE_INITHELPER_LOADIMAGEWITHMACRO \
+      MUI_LOADANDASPECTSTRETCHIMAGETOCONTROLHEIGHT
+
+  !else
+
+    !if "${MUI_HEADERIMAGE_${UN}BITMAP${RTL}_STRETCH}" != "FitControl"
+      !warning 'MUI_HEADERIMAGE_${UN}BITMAP${RTL}_STRETCH set to unknown value, defaulting to FitControl'
     !endif
+    SetBrandingImage /IMGID=${IMGRESID} /RESIZETOFIT "${PATH}"
 
-        File "/oname=$PLUGINSDIR\modern-header.bmp" "${MUI_HEADERIMAGE_${UNINSTALLER}BITMAP}"
+  !endif
 
-        !ifndef MUI_HEADERIMAGE_${UNINSTALLER}BITMAP_NOSTRETCH
-          SetBrandingImage /IMGID=1046 /RESIZETOFIT "$PLUGINSDIR\modern-header.bmp"
-        !else
-          SetBrandingImage /IMGID=1046 "$PLUGINSDIR\modern-header.bmp"
-        !endif
+!macroend
 
-    !ifdef MUI_HEADERIMAGE_${UNINSTALLER}BITMAP_RTL
+!macro MUI_HEADERIMAGE_INIT UN IMGRESID
 
-      ${endif}
+  ;Load and display header image
 
+  !ifdef MUI_HEADERIMAGE
+
+    InitPluginsDir
+
+    !ifdef MUI_HEADERIMAGE_${UN}BITMAP_RTL
+      ${if} $(^RTL) == 1
+
+        File "/oname=$PLUGINSDIR\modern-header.bmp" "${MUI_HEADERIMAGE_${UN}BITMAP_RTL}"
+        !insertmacro MUI_HEADERIMAGE_INITHELPER_LOADIMAGE "${UN}" "_RTL" ${IMGRESID} "$PLUGINSDIR\modern-header.bmp"
+
+      ${else}
     !endif
 
+        File "/oname=$PLUGINSDIR\modern-header.bmp" "${MUI_HEADERIMAGE_${UN}BITMAP}"
+        !insertmacro MUI_HEADERIMAGE_INITHELPER_LOADIMAGE "${UN}" "" ${IMGRESID} "$PLUGINSDIR\modern-header.bmp"
+
+    !ifdef MUI_HEADERIMAGE_${UN}BITMAP_RTL
+      ${endif}
+    !endif
+
   !endif
 
 !macroend
@@ -183,27 +238,29 @@
   GetDlgItem $mui.Header.Text $HWNDPARENT 1037
   CreateFont $mui.Header.Text.Font "$(^Font)" "$(^FontSize)" "700"
   SendMessage $mui.Header.Text ${WM_SETFONT} $mui.Header.Text.Font 0
-  
+
   GetDlgItem $mui.Header.SubText $HWNDPARENT 1038
 
   !ifndef MUI_HEADER_TRANSPARENT_TEXT
-    SetCtlColors $mui.Header.Text "" "${MUI_BGCOLOR}"
-    SetCtlColors $mui.Header.SubText "" "${MUI_BGCOLOR}"
+    SetCtlColors $mui.Header.Text "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
+    SetCtlColors $mui.Header.SubText "${MUI_TEXTCOLOR}" "${MUI_BGCOLOR}"
   !else
-    SetCtlColors $mui.Header.Text "" "transparent"
-    SetCtlColors $mui.Header.SubText "" "transparent"
+    SetCtlColors $mui.Header.Text "${MUI_TEXTCOLOR}" "transparent"
+    SetCtlColors $mui.Header.SubText "${MUI_TEXTCOLOR}" "transparent"
   !endif
-  
+
   ;Header image
-  !insertmacro MUI_HEADERIMAGE_INIT "${UNINSTALLER}"
+  !insertmacro MUI_HEADERIMAGE_INIT "${UNINSTALLER}" 1046
 
   ;Header background
   GetDlgItem $mui.Header.Background $HWNDPARENT 1034
   SetCtlColors $mui.Header.Background "" "${MUI_BGCOLOR}"
 
-  ;Header image background
-  GetDlgItem $mui.Header.Image $HWNDPARENT 1039
-  SetCtlColors $mui.Header.Image "" "${MUI_BGCOLOR}"
+  ;Header icon image background
+  !ifndef MUI_HEADERIMAGE
+    GetDlgItem $mui.Header.Image $HWNDPARENT 1039
+    SetCtlColors $mui.Header.Image "" "${MUI_BGCOLOR}"
+  !endif
 
   ;Branding text
   GetDlgItem $mui.Branding.Background $HWNDPARENT 1028
@@ -211,11 +268,11 @@
   GetDlgItem $mui.Branding.Text $HWNDPARENT 1256
   SetCtlColors $mui.Branding.Text /BRANDING
   SendMessage $mui.Branding.Text ${WM_SETTEXT} 0 "STR:$(^Branding) "
-  
+
   ;Lines
   GetDlgItem $mui.Line.Standard $HWNDPARENT 1035
   GetDlgItem $mui.Line.FullWindow $HWNDPARENT 1045
-  
+
   ;Buttons
   GetDlgItem $mui.Button.Next $HWNDPARENT 1
   GetDlgItem $mui.Button.Cancel $HWNDPARENT 2
